<?php

namespace Bydedi\Form\Constraint;

use Bydedi\Form\RequestAwareInterface;
use Symfony\Component\HttpFoundation\Request;

/**
 * Class Callback
 * @package Form\Constraint
 */
class Callback extends Constraint implements RequestAwareInterface
{

    /**
     * @var
     */
    protected $callback;

    /**
     * @var
     */
    protected $request;

    /**
     * @param array $callback
     */
    public function __construct(array $callback)
    {
        $this->setCallback($callback);
    }

    /**
     * @param $value
     * @return mixed
     */
    public function isValid($value)
    {
        return call_user_func_array($this->getCallback(), array($value, $this->getRequest()));
    }

    /**
     * @return mixed
     */
    public function getCallback()
    {
        return $this->callback;
    }

    /**
     * @param mixed $callback
     */
    public function setCallback($callback)
    {
        $this->callback = $callback;
    }

    /**
     * @param \Symfony\Component\HttpFoundation\Request $request
     */
    public function setRequest(Request $request)
    {
        $this->request = $request;
    }

    /**
     * @return mixed
     */
    public function getRequest()
    {
        return $this->request;
    }
}
