<?php

namespace Bydedi\Form\Constraint;

use Bydedi\Form\RequestAwareInterface;
use Symfony\Component\HttpFoundation\Request;

/**
 * Class File
 * @package Form\Constraint
 */
class File extends Constraint implements RequestAwareInterface
{

    protected $fileName;

    /**
     * @var \Symfony\Component\HttpFoundation\Request
     */
    protected $request;

    public function __construct($fileName)
    {
        $this->fileName = $fileName;
    }

    /**
     * @param $value
     * @return bool
     */
    public function isValid($value)
    {
        return (
            $this->request->files->get($this->fileName) != false &&
            $this->request->files->get($this->fileName)->getError() == 0
        );
    }

    /**
     * @param Request $request
     */
    public function setRequest(Request $request)
    {
        $this->request = $request;
    }
}
