<?php

namespace Bydedi\Form\Constraint;

/**
 * Class Length
 * @package Form\Constraint
 */
class Length extends Constraint
{
    /**
     * @var
     */
    protected $min;

    /**
     * @var
     */
    protected $max;

    /**
     * @param $min
     * @param $max
     */
    public function __construct($min, $max)
    {
        $this->setMin($min);
        $this->setMax($max);
    }

    /**
     * @param $value
     * @return bool
     */
    public function isValid($value)
    {
        return (strlen($value) >= $this->getMin() && strlen($value) <= $this->getMax());
    }

    /**
     * @return mixed
     */
    public function getMin()
    {
        return $this->min;
    }

    /**
     * @param mixed $min
     */
    public function setMin($min)
    {
        $this->min = $min;
    }

    /**
     * @return mixed
     */
    public function getMax()
    {
        return $this->max;
    }

    /**
     * @param mixed $max
     */
    public function setMax($max)
    {
        $this->max = $max;
    }
}
