<?php

namespace Bydedi\Form\Constraint;

use Bydedi\Form\RequestAwareInterface;
use Symfony\Component\HttpFoundation\Request;

/**
 * Class UnequalToField
 * @package Form\Constraint
 */
class UnequalToField extends Constraint implements RequestAwareInterface
{
    /**
     * @var String
     */
    protected $targetField;

    /**
     * @var \Symfony\Component\HttpFoundation\Request
     */
    protected $request;

    /**
     * @param $target
     */
    public function __construct($target)
    {
        $this->setTargetField($target);
    }

    /**
     * @param $value
     * @return bool
     */
    public function isValid($value)
    {
        if (empty($value)) {
            return true;
        }

        return $value != $this->request->get($this->getTargetField());
    }

    /**
     * @return mixed
     */
    public function getTargetField()
    {
        return $this->targetField;
    }

    /**
     * @param mixed $targetField
     */
    public function setTargetField($targetField)
    {
        $this->targetField = $targetField;
    }

    /**
     * @param Request $request
     */
    public function setRequest(Request $request)
    {
        $this->request = $request;
    }
}